function loadPresentation(){
function initReveal(modules) {
	var path='../reveal/';
	var loaded={};
        var options={	controls: true, progress: true, history: false, center: false, mouseWheel: false,
			margin: 0.05, width: 1600, height: 900,
			minScale: 0.2,	maxScale: 2.0,
			math: { config:'TeX-MML-AM_HTMLorMML&locale=ru' },
			menu: { numbers: true, openSlideNumber: true,
				themes: true, themesPath: path+'css/theme/',
				transitions: false, markers: false, hideMissingTitles: true },
			audio: {prefix: 'audio/', suffix: '.ogg', defaultDuration: 10,
				advance: 500, autoplay: false,
				defaultNotes: true, defaultText: false,
				playerOpacity: 0.2 },
			theme: Reveal.getQueryHash().theme, 
			transition: Reveal.getQueryHash().transition || 'default', // none/fade/slide/convex/concave/zoom
			anything: [{ className: "plot",  defaults: {width:500, height: 500, grid:true,  disableZoom: true}, 
					initialize: (function(container, options){
						options=options || {};
						options.target = "#"+container.id; 
						var instance = functionPlot(options);
						instance.on('mousemove', 
							function (coordinates) {
								if ( document.querySelector(".slides").style.zoom ) {
									document.scaleX = document.querySelector(".slides").style.zoom;
								}
								else if ( document.querySelector(".slides").style.transform ) {
									var s = document.querySelector(".slides").style.transform;
									s = s.substr( s.indexOf("scale"), s.length );
									s = s.substr( s.indexOf("(") + 1, s.indexOf(")") - s.indexOf("(") - 1);
									document.scaleX = s;
								}
								else {
									document.scaleX = 1;
								}
							});

						}) 
				}],
			chalkboard: { 
				src: 'chalkboard.json',
				toggleChalkboardButton: { left: "80px" },
				toggleNotesButton: { left: "130px" },
				},
			markdown: {sanitize:true},
			chart: {
				defaults: { 
					global: { title: { fontColor: "#FFF" }, 
						legend: { position: "bottom", labels: { fontColor: "#FFF" }},
						tooltips: { labels: { fontColor: "#FFF" } },
						}, 
						scale: { scaleLabel: { fontColor: "#FFF" }, 
							gridLines: { color: "#FFF", zeroLineColor: "#FFF" }, 
							ticks: { fontColor: "#FFF" }, 
						} 
					},
					line: { borderColor: [ "rgba(20,220,220,.8)" , "rgba(220,120,120,.8)", "rgba(20,120,220,.8)" ], "borderDash": [ [5,10], [0,0] ] }, 
					bar: { backgroundColor: [ "rgba(20,220,220,.8)" , "rgba(220,120,120,.8)", "rgba(20,120,220,.8)" ]}, 
					pie: { backgroundColor: [ ["rgba(0,0,0,.8)" , "rgba(220,20,20,.8)", "rgba(20,220,20,.8)", "rgba(220,220,20,.8)", "rgba(20,20,220,.8)"] ]},
					radar: { borderColor: [ "rgba(20,220,220,.8)" , "rgba(220,120,120,.8)", "rgba(20,120,220,.8)" ]}
				}
                    };
        var module_re=/[^ \t+]+/g;
        var res_re=/^([0-9]+)x([0-9]+)$/;
        var resolution=null;
        var module=null;
        var dependencies=      [{ src: path+'lib/js/classList.js', condition: function() { return !document.body.classList; } },
				{ src: path+'plugin/menu/menu.js' }];
        var keyboard={};
        while(module=module_re.exec(modules)) {
		var name=module[0];
		var pos=name.indexOf(':');
 		if(pos>=0) name=name.substr(0,pos);
		if(loaded[name]) continue;
		loaded[name]=true;
		if(module[0]=='center') options.center=true;
		else if(module[0]=='wheel') options.mouseWheel=true;
		else if(module[0].substr(0,8)=='autoplay') {
			if(module[0].substr(0,9)=='autoplay:')
				options.audio.defaultDuration=0+module[0].substr(9);
			options.audio.autoplay=true;
		}
		else if(module[0]=='history') options.history=true;
		else if(module[0]=='number') options.slideNumber='c';
		else if(module[0]=='mp3') options.audio.suffix='.mp3';
		else if(module[0]=='math') {
			options.markdown.mathjax=true;
			dependencies.push({ src: path+'plugin/math/math.js' });
		}
		else if(module[0]=='board') { 
			dependencies.push({ src: path+'plugin/chalkboard/chalkboard.js'});
			keyboard[66 /*b*/]=function() { RevealChalkboard.toggleChalkboard() };
			keyboard[67 /*c*/]=function() { RevealChalkboard.toggleNotesCanvas() };
			keyboard[68 /*d*/]=function() { RevealChalkboard.download() };
			keyboard[46 /*Del*/]=function() { RevealChalkboard.clear() };
			keyboard[8 /*backspace*/]=function() { RevealChalkboard.reset() };
		}
		else if(module[0]=='markdown') { 
			dependencies.push({ src: path+'plugin/markdown/marked.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } });
			dependencies.push({ src: path+'plugin/markdown/markdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } });
		}
		else if(module[0]=='plot') { 
			dependencies.push({ src: path+'plugin/anything/d3/d3.v3.min.js' });
			dependencies.push({ src: path+'plugin/anything/d3.patch.js' });
			dependencies.push({ src: path+'plugin/anything/function-plot.js' });
			dependencies.push({ src: path+'plugin/anything/anything.js' });
		}
		else if(module[0]=='notes') dependencies.push({ src: path+'plugin/notes/notes.js', async: true }); /*key s */
		else if(module[0]=='search') dependencies.push({ src: path+'plugin/search/search.js', async: true }); /*Ctrl-Shift-F*/
		else if(module[0]=='zoom') dependencies.push({ src: path+'plugin/zoom-js/zoom.js', async: true }); /*Alt+left mouse */
		else if(module[0]=='chart') { 
			dependencies.push({ src: path+'plugin/chart/Chart.min.js' });
			dependencies.push({ src: path+'plugin/chart/csv2chart.js' });
		}
		else if(module[0]=='audio') { 
			dependencies.push({ src: path+'plugin/audio-slideshow/audio-slideshow.js', condition: function( ) { return !!document.body.classList; } });
		}
		else if(module[0]=='recorder') { 
			dependencies.push({ src: path+'plugin/audio-slideshow/RecordRTC.js', condition: function( ) { return !!document.body.classList; } });
			dependencies.push({ src: path+'plugin/audio-slideshow/slideshow-recorder.js', condition: function( ) { return !!document.body.classList; } });
			keyboard[82 /*r*/]=function() { Recorder.toggleRecording(); };
			keyboard[90 /*z*/]=function() { Recorder.downloadZip(); };
		}
		else if(module[0]=='spreadsheet') {
			dependencies.push({ src: path+'plugin/spreadsheet/ruleJS.all.full.min.js' });
			dependencies.push({ src: path+'plugin/spreadsheet/spreadsheet.js' });
		}
		else if(module[0].substr(0,4)=='code') { 
                        if(module[0].substr(0,5)=='code:')
				document.getElementById('theme-code').setAttribute('href',path+'plugin/highlight/styles/'+module[0].substr(5)+'.css');
			dependencies.push({ src: path+'plugin/highlight/highlight.pack.js'});
			dependencies.push({ src: path+'plugin/highlight/highlight.js', async: true});
		}
		else if(module[0]=='quiz') { 
			dependencies.push({ src: path+'plugin/quiz/jquery-3.3.1.min.js'});
			dependencies.push({ src: path+'plugin/quiz/slickQuiz.js'});
			dependencies.push({ src: path+'plugin/quiz/quiz.js', async: true});
		}
		else if(module[0].substr(0,6)=='theme:') {
			document.getElementById('theme').setAttribute('href',path+'css/theme/'+module[0].substr(6)+'.css');
		}
		else if(resolution=res_re.exec(module[0])) {
			options.width=parseInt(resolution[1],10);
			options.height=parseInt(resolution[2],10);
                }
        }
        options.keyboard=keyboard;
        options.dependencies=dependencies;
        window.Reveal.initialize(options);
}

function tryLoadHTML() {
   var xhr = new XMLHttpRequest();
   xhr.open('GET', 'presentation.html', true);
   xhr.overrideMimeType("text/plain; charset=utf-8");
   xhr.send();
   xhr.onreadystatechange = 
   function() {
     if (xhr.readyState != 4) return;
     if (xhr.status != 200) {
        document.getElementById("presentation").innerText= 'Error '+xhr.status + ': ' + xhr.statusText;
     } 
     else {
        var moduleList=/<!--([-+:a-z0-9 ]+)-->/.exec(xhr.responseText);
        if(moduleList==null) {
		document.getElementById("presentation").innerText='No parameters';
		return null;
        }
        document.getElementById("presentation").innerHTML=xhr.responseText;
	initReveal(moduleList[1]);
     }
  }
}

if(window.presentationLoaded) return null;
   window.presentationLoaded=true;
window.mdRenderer={};
tryLoadHTML();
}
