function loadPresentation(){


function toUTF8Array(str) {
    var utf8 = [];
    for (var i=0; i < str.length; i++) {
        var charcode = str.charCodeAt(i);
        if (charcode < 0x80) utf8.push(charcode);
        else if (charcode < 0x800) {
            utf8.push(0xc0 | (charcode >> 6), 
                      0x80 | (charcode & 0x3f));
        }
        else if (charcode < 0xd800 || charcode >= 0xe000) {
            utf8.push(0xe0 | (charcode >> 12), 
                      0x80 | ((charcode>>6) & 0x3f), 
                      0x80 | (charcode & 0x3f));
        }
        // surrogate pair
        else {
            i++;
            charcode = ((charcode&0x3ff)<<10)|(str.charCodeAt(i)&0x3ff)
            utf8.push(0xf0 | (charcode >>18), 
                      0x80 | ((charcode>>12) & 0x3f), 
                      0x80 | ((charcode>>6) & 0x3f), 
                      0x80 | (charcode & 0x3f));
        }
    }
    return utf8;
}
function encode64(data) {
	var r = "";
	var encodeChars="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-_";
	for (var i=0; i<data.length; i+=3) {
		var b1=data.charCodeAt(i);
		var b2=0;
		var b3=0;
 		if (i+1<data.length) {
			b2=data.charCodeAt(i+1);
		} 
		if (i+2<data.length) {
			b3=data.charCodeAt(i+2);
		}
		r += encodeChars.charAt((b1 >> 2) & 0x3F);
		r += encodeChars.charAt((((b1 & 0x3) << 4) | (b2 >> 4)) & 0x3F);
		r += encodeChars.charAt((((b2 & 0xF) << 2) | (b3 >> 6)) & 0x3F);
		r += encodeChars.charAt(b3 & 0x3F);
	}
	return r;
}

function renderPlant(code, escaped, styles, opts, lang) {
           var format='svg';
           if(/format=png/.test(opts)) format='png';
           var src=encode64(deflate(toUTF8Array(code),9));
           return "<img "+(styles!=''?"style=\""+styles+"\" ":'')+"src=\"https://ipc.susu.ru/"+lang+"/"+src+"."+format+"\">\n";
	};

function tryLoadMarkDown() {
   var xhr = new XMLHttpRequest();
   xhr.open('GET', 'presentation.md', true);
   xhr.overrideMimeType("text/plain; charset=utf-8");
   xhr.send();
   xhr.onreadystatechange = 
   function() {
     if (xhr.readyState != 4) return;
     if (xhr.status == 200) {
        var moduleList=/^<!--([-+:a-z0-9 ]+)-->/.exec(xhr.responseText);
        if(moduleList==null) {
		document.getElementById("presentation").innerText='No parameters';
		return null;
        }
        var text=xhr.responseText;
        text=text.substr(text.indexOf(">")+1);
	text=text.replace(/\n--\r?\n/g,"\n");
 	var renderer=new marked.Renderer();
	var options={sanitize:true, mathjax:true};
	options.renderer=renderer;
			renderer.code=function(code, infostring, escaped) {
                                var matches=/(.*?[|])?(\S*)\s*(.*)/.exec(infostring || '');
				var lang = matches[2];
 				var opts= matches[3] || '';
                                var styles='';
                                if(matches[1]) {
					styles=matches[1].substring(0,matches[1].length-1);
				}
				if (!lang) {
                                  return '<pre><code>'
                                     + mdRenderer['escape'](code, escaped)
                                     + '</code></pre>';
                                }
				if (window.mdRenderer.hasOwnProperty(lang)) {
					return window.mdRenderer[lang](code, escaped, styles, opts);
				}

				return '<pre><code class="'
				    + this.options.langPrefix  + mdRenderer['escape'](lang, escaped)
				    + '">' + mdRenderer['escape'](code, escaped) + '</code></pre>\n';
			};

        window.mdRenderer.uml=function(code, escaped, styles, opts) {
           return renderPlant(code,escaped,styles,opts,'uml');
	};
        window.mdRenderer.salt=function(code, escaped, styles, opts) {
           return renderPlant(code,escaped,styles,opts,'salt');
	};
        window.mdRenderer.dot=function(code, escaped, styles, opts) {
           return renderPlant(code,escaped,styles,opts,'dot');
	};
        window.mdRenderer.mindmap=function(code, escaped, styles, opts) {
           return renderPlant(code,escaped,styles,opts,'mindmap');
	};
        window.mdRenderer.gantt=function(code, escaped, styles, opts) {
           return renderPlant(code,escaped,styles,opts,'gantt');
	};
	marked.setOptions( options );

        document.getElementById("presentation").innerHTML=marked(text);
		
        var hljs_nodes = document.querySelectorAll( 'pre code' );

	for( var i = 0, len = hljs_nodes.length; i < len; i++ ) {
		var element = hljs_nodes[i];
		hljs.highlightBlock(element);
	}
        Spreadsheet();
        Plot();
        MathJax.Hub.Typeset();
     }
  }
}

if(window.presentationLoaded) return null;
   window.presentationLoaded=true;
tryLoadMarkDown();
}
