var RevealPlantUML = window.RevealPlantUML || (function(){
function toUTF8Array(str) {
    var utf8 = [];
    for (var i=0; i < str.length; i++) {
        var charcode = str.charCodeAt(i);
        if (charcode < 0x80) utf8.push(charcode);
        else if (charcode < 0x800) {
            utf8.push(0xc0 | (charcode >> 6), 
                      0x80 | (charcode & 0x3f));
        }
        else if (charcode < 0xd800 || charcode >= 0xe000) {
            utf8.push(0xe0 | (charcode >> 12), 
                      0x80 | ((charcode>>6) & 0x3f), 
                      0x80 | (charcode & 0x3f));
        }
        // surrogate pair
        else {
            i++;
            charcode = ((charcode&0x3ff)<<10)|(str.charCodeAt(i)&0x3ff)
            utf8.push(0xf0 | (charcode >>18), 
                      0x80 | ((charcode>>12) & 0x3f), 
                      0x80 | ((charcode>>6) & 0x3f), 
                      0x80 | (charcode & 0x3f));
        }
    }
    return utf8;
}
function encode64(data) {
	var r = "";
	var encodeChars="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-_";
	for (var i=0; i<data.length; i+=3) {
		var b1=data.charCodeAt(i);
		var b2=0;
		var b3=0;
 		if (i+1<data.length) {
			b2=data.charCodeAt(i+1);
		} 
		if (i+2<data.length) {
			b3=data.charCodeAt(i+2);
		}
		r += encodeChars.charAt((b1 >> 2) & 0x3F);
		r += encodeChars.charAt((((b1 & 0x3) << 4) | (b2 >> 4)) & 0x3F);
		r += encodeChars.charAt((((b2 & 0xF) << 2) | (b3 >> 6)) & 0x3F);
		r += encodeChars.charAt(b3 & 0x3F);
	}
	return r;
}
function renderPlant(code, escaped, styles, opts, lang) {
           var format='svg';
           if(/format=png/.test(opts)) format='png';
           var src=encode64(deflate(toUTF8Array(code),9));
           return "<img "+(styles!=''?"style=\""+styles+"\" ":'')+"src=\"https://ipc.susu.ru/"+lang+"/"+src+"."+format+"\">\n";
	};

	var config = Reveal.getConfig().uml || {};
        window.mdRenderer.uml=function(code, escaped, styles, opts) {
           return renderPlant(code,escaped,styles,opts,'uml');
	};
        window.mdRenderer.salt=function(code, escaped, styles, opts) {
           return renderPlant(code,escaped,styles,opts,'salt');
	};
        window.mdRenderer.dot=function(code, escaped, styles, opts) {
           return renderPlant(code,escaped,styles,opts,'dot');
	};
        window.mdRenderer.mindmap=function(code, escaped, styles, opts) {
           return renderPlant(code,escaped,styles,opts,'mindmap');
	};
        window.mdRenderer.gantt=function(code, escaped, styles, opts) {
           return renderPlant(code,escaped,styles,opts,'gantt');
	};
})();
